global {
   str defpsw
}

define {
   RADIO1 = 0xc82
   RADIO2 = 0xc83
   CHECK1 = 0xc20  
   CHECK2 = 0xc21  
   EDIT1 = 0xceb  
   EDIT2 = 0xced 
   PSW	= 0xcf0
   PSW2	= 0xcf2
}

func mychange( uint wnd )
{
   str stemp
   win_gettext( wnd, stemp )
   if !*stemp : win_settext( wnd, "#default_text#")
}

func mypsw( uint wnd )
{
   str psw
   win_gettext( GetDlgItem( wnd, $PSW ), psw )
   win_enable( GetDlgItem( wnd, $IDC_NEXT ), psw == defpsw )
   win_settext( GetDlgItem( wnd, $PSW2 ), psw )

}

func myenable( uint wnd )
{
    uint first =  wcheck_get( GetDlgItem( wnd, $RADIO1 ))
    win_enable(  GetDlgItem( wnd, $CHECK1 ), first )
    win_enable(  GetDlgItem( wnd, $CHECK2 ), !first )
    win_enable(  GetDlgItem( wnd, $EDIT1 ), first )
    win_enable(  GetDlgItem( wnd, $EDIT2 ), !first )
    mychange( GetDlgItem( wnd, $EDIT1 ) )    
    mychange( GetDlgItem( wnd, $EDIT2 ) )
    mypsw( wnd )    
}

func myfocus( uint wnd )
{
   str stemp
   win_gettext( wnd, stemp )
   if stemp == macrox_get( "default_text" ) : win_settext( wnd, "" )
}

func uint mydlgsetscmdproc( uint wnd id ctl codedlg )
{
   switch id
   {
      case $RADIO1, $RADIO2
      {
         if  codedlg == $BN_CLICKED : myenable( wnd )
      }
      case $EDIT1, $EDIT2
      {
         if codedlg == $EN_SETFOCUS : myfocus( GetDlgItem( wnd, id ))
         if codedlg == $EN_KILLFOCUS : mychange( GetDlgItem( wnd, id ))
      }
      case $PSW
      {
         if codedlg == $EN_CHANGE : mypsw( wnd )
      }
      case $DLGINIT 
      {
         uint ret = dlgsetscmdproc( wnd, id, ctl, codedlg )
         macrox_getstr( "defpsw", defpsw ) 
         myenable( wnd )
         return ret
      }
//    case $IDC_PREV : 
      case $IDC_NEXT 
      {
         uint idedit first = wcheck_get( GetDlgItem( wnd, $RADIO1 ))
         str  curname      
         
         idedit = GetDlgItem( wnd, ?( first, $EDIT1, $EDIT2 ))
         win_gettext( idedit, curname )
         if curname == macrox_get( "default_text" ) || !*curname
         {
            msg_warning( "#warningmsg#", "#lcaption#" )
            SetFocus( idedit )
            return 0
         }              
      } 
   }
   return dlgsetscmdproc( wnd, id, ctl, codedlg )
}
